<template>
  <div
    class="min-h-full flex items-center justify-center py-12 px-4 sm:px-6 lg:px-8"
  >

    <div
      class="max-w-lg w-full space-y-8 bg-white p-4 md:px-8 md:py-16 shadow-xl"
    >
      <div class="text-indigo-600">
        <div class="flex justify-center">
          <font-awesome-icon icon="dungeon" size="5x"/>  
        </div>
        <h2 class="mt-6 text-center text-3xl font-extrabold text-gray-900">
          Se connecter
        </h2>
      </div>
      <form
        class="mt-8 space-y-6"
        method="POST"
        @submit="login"
      >
        <div class="rounded-md shadow-sm -space-y-px">
          <TextField
            label="Email"
            id="email-address"
            name="email"
            type="email"
            :value="values.email"
            @input="values[$event.target.name] = $event.target.value"
            required
            placeholder="exemple@domaine.fr"
          />
          <TextField
            label="Mot de passe"
            id="password"
            name="password"
            type="password"
            :value="values.password"
            @input="values[$event.target.name] = $event.target.value"
            required
            placeholder="Mot de passe"
            class="pt-8"
          />
        </div>

        <div class="pt-10">
          <Button type="submit" icon="lock" label="Se connecter" />
        </div>
      </form>
    </div>
  </div>
</template>

<script>
import TextField from "./Form/Field/TextField"
import Button from "./Form/ButtonForm"

export default {
  name: "Login",
  components: {
    TextField,
    Button
  },
  data: () => ({
    loginUrl: `https://${window.location.hostname}:8443/authentication_token`,
    values: {
      email: "",
      password: ""
    }
  }),
  inject: ["addLoginInfo", "createAlert"],
  methods: {
    login: function(e) {
      e.preventDefault()

      fetch(this.loginUrl, {
        headers: {
          Accept: "application/json",
          "Content-Type": "application/json",
        },
        method: "POST",
        body: JSON.stringify(this.values)
      })
        .then(async (res) => {
          if (res.status === 200) {
            this.createAlert({
              color: "green",
              text: "Connection réussi",
              icon: "check"
            })

            const data = await res.json()
            const userData = JSON.parse(atob(data.token.split(".")[1]))
            this.addLoginInfo(data.token, userData)
            this.$router.go()
          } else {
            this.createAlert({
              color: "red",
              text: res.status === 401 ? "Connexion échouée" : "Une erreur est survenue",
              icon: "times"
            })
          }
        })
        .catch(() => {
          this.createAlert({
            color: "red",
            text: "Une erreur est survenue",
            icon: "times"
          })
        })
    }
  }
}
</script>

<style scoped>

</style>